<?php
////////////////////////////////////////////////////////
//PHP-Nuke 7.1 -> Drupal 4.6 Migrator                 //
//April 17th 2005                                     //
//If you have questions or bug reports contact me via://
//http://www.quillem.com/nuke2drupal                  //
//Karthik Kumar                                       //
////////////////////////////////////////////////////////
?>


<?php
	error_reporting(E_ALL);
	ini_set('display_errors', true);
	ini_set('html_errors', true);
	ini_set('max_execution_time', "600");
	/////////////////////////////////////




	//This is what you edit.
	//Database config 
	$host = "localhost"; //Host address for MySQL
	$username = "root"; //Username to connect to MySQL
	$password = ""; //Password to connect to MySQL
	$nuke = "nukedb"; //Name of the Nuke database
	$drupal = "drupaldb";//Name of the Drupal database
	//Users already added [anonymous should always be present]
	$user_array = array("anonymous", "admin");
	/////////////////////////////////////
	//You shouldn't have to modify anything below this.
	
	
	


	
	//Tables
	$n_users = $nuke.".nuke_users";
	$n_stories = $nuke.".nuke_stories";
	$n_fora = $nuke.".nuke_bbforums";
	$n_posts = $nuke.".nuke_bbposts";
	$n_posts_text = $nuke.".nuke_bbposts_text";
	$n_topics = $nuke.".nuke_bbtopics";

	$d_users = $drupal.".users";
	$d_roles = $drupal.".users_roles";
	$d_nodes = $drupal.".node";
	$d_sequences = $drupal.".sequences";
	$d_fora = $drupal.".forum";
	$d_comments = $drupal.".comments";
	$d_comment_statistics = $drupal.".node_comment_statistics";
	$d_term_data = $drupal.".term_data";
	$d_term_node = $drupal.".term_node";
	$d_term_hierarchy = $drupal.".term_hierarchy";
	$d_variables = $drupal.".variable";
	$d_vocabulary = $drupal.".vocabulary";

	$role_string = 'a:1:{s:5:"roles";a:1:{i:0;s:1:"2";}}';
	$comment_user_string = 'a:1:{i:0;i:0;}';
	//Story HTML format - 
	//1 = Basic HTML 2 = PHP Allowed 3 = All HTML (3 - recommended)
	$format = 3;
	$promote = 1;
	$comment = 2;
	$node_stype = "story";
	$node_ftype = "forum";

	$forum_container = "Archived Nuke Fora";
	$container_description = "Nuke Fora transferred to drupal. Will need to be reorganised.";
	/////////////////////////////////
	//Functions
	//Gets the vid for a field (forums) from the vocabulary table
	
	function get_vid($name)
	{
		//message("Getting current vid for $name");
		$d_vocabulary = $GLOBALS["d_vocabulary"];
		$query = "SELECT vid FROM $d_vocabulary where name='$name'";
		$result = mysql_query($query);
		if ($row = mysql_fetch_object($result))
		{
			//success("vid for $name retrieved!");
			return($row->vid);
		}
		else
		{
			failure("MySQL Error: vid for $name could not be retrieved");
			exit();
		}
	}
	
	//Gets the max_id from the sequences table for a particular id.
	//This is because the tables don't/shouldn't really use the auto_increment featureof MySQL/pgSQL
	//as it is not ANSI compliant. So Drupal stores the next auto_increment value in a separate table.
	function get_max_id($field)
	{
		//message("Getting Max ID for $field");
		$d_sequences = $GLOBALS["d_sequences"];
		$query = "SELECT id FROM $d_sequences WHERE name='$field'";
		$result = mysql_query($query);
		if ($row = mysql_fetch_object($result))
		{
			//success("Max ID for $field retrieved!");
			return($row->id);
		}
		else
		{
			failure("MySQL Error: Max ID for $field could not be retrieved");
			exit();
		}
	}
	
	//Updates the above mentioned field once a row(s) is inserted.
	function set_max_id($field, $value)
	{
		//message("Updating Max ID for $field");
		$d_sequences = $GLOBALS["d_sequences"];
		$query = "UPDATE $d_sequences SET id='$value' WHERE name='$field'";
		$result = mysql_query($query);
		if (!$result)
		{
			failure("MySQL Error: Max ID for $field could not be updated");
			exit();
		}
		//success("Max ID for $field updated!");
	}
	//Convert Hex IP to standard octet form
	function get_ip($hexip)
	{
		$ip = array();
		for ($i = 0; $i < 4; $i++)
		{
			$octal = substr($hexip, $i * 2, 2);
			$ip[$i] = hexdec($octal);
		}
		return(implode(".", $ip));
	}
	//Display functions
	//Displays page headings
	function mainheading($str)
	{
		echo "<h3>$str</h3>";
	}
	function heading($str)
	{
		echo "<h4>$str:</h4>";
	}
	function message($str)
	{
		echo "<div class='message'>$str</div>";
	}
	function success($str)
	{
		echo "<div class='success'>$str</div>";
	}
	function failure($str)
	{
		echo "<div class='failure'>$str</div>";
		echo "<div class='options'>";
		echo "&nbsp;<a href='migrate.php'>Back To Main?</a>";
		echo "</div>";
	}
	//Connect to MySQL
	$connected = true;
	$link = @mysql_connect($host, $username, $password);
	if (!$link)
	{
		failure("Connection to MySQL could not be made. Edit this file and make sure that the database settings are correct.");
		$connected = false;
		if (isset($_GET["section"]))
		{
			exit();
		}
	}
	////////////////////////////////
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
		<title>Nuke Migrator</title>
		<style type="text/css">
			body
			{
				margin: 0px;
				padding: 0px;
				background-color:#FCFCFC;
			}
			.container
			{
				margin:1em;
				padding:0.5em;
				border:1px dashed #AAAAAA;
			}
			.container ul
			{
				margin:0;
			}
			h3
			{
				color:#000099;
				padding:0.5em;
				padding-top:0;
				padding-bottom:0.2em;
				margin-top:1em;
				margin-bottom:0;
			}
			h4
			{
				margin:0;
				color:#993333;
				padding-bottom:1em;
				text-transform:capitalize;
				font-variant:small-caps;
			}
			.options
			{
				margin:1em;
				border-top:1px dashed #CCCCCC;
				text-align:right;
			}
			.important
			{
				color:#FF0000;
			}
			.message, .success, .failure
			{
				margin-bottom:0.5em;
				padding:0.2em;
				padding-left:0.7em;
			}
			.message
			{
				background-color:#CCCCCC;
			}
			.success
			{
				background-color:#90CC90;
			}
			.failure
			{
				background-color:#FF9999;
			}
		</style>
	</head>
	<body>
		<?php 
			mainheading("Nuke &rsaquo;&rsaquo; Drupal Migrator");
		?>
		<div class="container">
			<?php
				$section = (isset($_GET["section"]))?$_GET["section"]:"";
				switch ($section)
				{
					case "users":
						heading("Migrating users");
						message("Giving blank usernames a default value..");
						$query = "UPDATE $n_users set name='temp_name' where name=''";
						$result = mysql_query($query, $link);
						if ($result)
						{
							success("Default values set..(".mysql_affected_rows()." rows affected)");
						}
						else
						{
							failure("Default values could not be set");
							exit();
						}
						$maxuid = get_max_id("users_uid");
						message("Transferring User Details to Drupal..");
						$query = "INSERT into $d_users(uid, name, pass, mail, created, changed, status, init, data) ";
						$query .= "SELECT @a:= $maxuid + 1 + user_id, username, user_password, user_email, UNIX_TIMESTAMP(), UNIX_TIMESTAMP(), 1, user_email, '$role_string' ";
						$query .= "FROM $n_users ";
						$query .= "WHERE 1=1 ";
						for ($i = 0; $i < count($user_array); $i++)
						{
							$query .= "AND username != '$user_array[$i]' ";
						}
						$result = mysql_query($query, $link);
						if ($result)
						{
							$newusers = mysql_affected_rows();
							success("Users Added..(".$newusers." rows affected)");
							set_max_id("users_uid", $maxuid + $newusers);
							$query = "insert into $d_roles(uid, rid) ";
							$query .= "SELECT uid, 2 AS rid ";
							$query .= "FROM $d_users ";
							$query .= "WHERE uid > $maxuid ";
							$result = mysql_query($query, $link);
							if ($result)
							{
								success("User roles updated - all users registered as authenticated users (role = 2).");
							}
							else
							{
								failure("Users Roles could not be added. It could be that there are duplicate usernames that are causing conflicts.");
								exit();
							}
						}
						else
						{
							failure("Users could not be added.");
							exit();
						}
						echo "<div class='options'>";
						echo "<a href='migrate.php?section=stories'>Migrate Stories?</a>";
						echo "&nbsp;<a href='migrate.php'>Back To Main?</a>";
						echo "</div>";
						break;
						//////////////////////////////////////////////////////////////////////////////////////////
					case "stories":
						heading("Migrating Stories");
						$maxnid = get_max_id("node_nid");
						$query = "SELECT $d_users.uid, $n_stories.title, UNIX_TIMESTAMP($n_stories.time) AS time, $n_stories.hometext, $n_stories.bodytext ";
						$query .= "FROM $n_stories, $d_users ";
						$query .= "WHERE $n_stories.aid=$d_users.name OR ($n_stories.aid='anonymous' AND $d_users.uid=0)";
						message("Retrieving stories from PHP-Nuke");
						$result = mysql_query($query, $link);
						if ($result)
						{
							success("Retrieved Stories From Nuke");
							message("Adding retrieved stories into Drupal. This may take a while..");
							$nid = $maxnid + 1;
							while ($row = mysql_fetch_object($result))
							{
								$row->hometext = addslashes($row->hometext);
								$row->bodytext = addslashes($row->bodytext);
								$row->title = addslashes($row->title);
								$query = "INSERT INTO $d_nodes(nid, type, title, uid, created, changed, comment, promote, teaser, body, format) ";
								$query .= "VALUES ('$nid', '$node_stype', '$row->title', '$row->uid', '$row->time', '$row->time', '$comment', '$promote', 
												   '$row->hometext', '".$row->hometext."<p>".$row->bodytext."</p>"."', '$format')";
								$result2 = mysql_query($query, $link);
								//message("Inserting Story '$title' into database");
								if (!$result2)
								{
									failure("Error transferring story '$title'. ".($nid - $maxnid - 1)." stories transferred");
									exit();
								}
								else
								{
									//success("Story '$title' inserted");
								}
								//message("Inserting row into comment statistics table");
								$query = "INSERT INTO $d_comment_statistics(nid, last_comment_timestamp, last_comment_uid, comment_count) ";
								$query .= "VALUES ('$nid', '$row->time', '$row->uid', '0')";
								$result2 = mysql_query($query, $link);
								if (!$result2)
								{
									failure("Post comments statistics registration failed");
									exit();
								}
								else
								{
									//success("Story '$title' comment statistics inserted");
								}
								$nid++;
							}
							set_max_id("node_nid", $nid - 1);
							success(($nid - $maxnid - 1)." Stories transferred successfully!");
						}
						else
						{
							failure("MySQL error. Nuke Stories could not be retrieved.");
							exit();
						}
						echo "<div class='options'>";
						echo "<a href='migrate.php?section=fora'>Migrate Fora?</a>";
						echo "&nbsp;<a href='migrate.php'>Back To Main?</a>";
						echo "</div>";
						break;
						//////////////////////////////////////////////////////////////////////////////////////////
					case "fora":
						heading("Migrating Fora");
						$maxtid = get_max_id("term_data_tid");
						$vid = get_vid("Forums");
						$maxtid++;
						//archive_id : To set parent forum later on
						$archive_id = $maxtid;
						$query = "INSERT INTO $d_term_data(tid, vid, name, description) ";
						$query .= "VALUES ('$maxtid', '$vid', '$forum_container', '$container_description')";
						//Insert Archive forum
						message("Insert Archive forum");
						$result = mysql_query($query, $link);
						if (!$result)
						{
							failure("Could not create Parent Forum.");
							exit();
						}
						success("Parent Forum Added");
						//////////////////////////////
						//Insert Archive Forum information into hierarchy table with parent as root (0)
						$query = "INSERT INTO $d_term_hierarchy(tid, parent) ";
						$query .= "VALUES ('$maxtid', '0')";
						message("Insert Archive Forum information into hierarchy table with parent as root (0)");
						$result = mysql_query($query, $link);
						if (!$result)
						{
							exit("Could not set container hierarchy.");
						}
						success("Parent Forum Hierarchy Established");
						//Copy forum names and descriptions over to drupal from nuke
						$query = "SELECT forum_id, forum_name, forum_desc FROM $n_fora";
						message("Copy forum names and descriptions over to Drupal from Nuke");
						$result = mysql_query($query, $link);
						if (!$result)
						{
							failure("Nuke Fora Could not be retrieved.");
							exit();
						}
						success("Nuke Fora retrieved");
						message("Inserting fora and associated posts into Drupal now. This may take a while..");
						$counter = 1;
						while ($row = mysql_fetch_object($result))
						{
							$maxtid++;
							$row->forum_name = addslashes($row->forum_name);
							$row->forum_desc = addslashes($row->forum_desc);
							$forum_id = $row->forum_id;
							//message("Creating $row->forum_name forum in Drupal");
							$query = "INSERT INTO $d_term_data(tid, vid, name, description) ";
							$query .= "VALUES ('$maxtid', '$vid', '$row->forum_name', '$row->forum_desc')";
							$result2 = mysql_query($query, $link);
							if (!$result2)
							{
								failure("Error transferring forum titles.. Exiting.. ");
								exit();
							}
							$counter++;
							success("Created '$row->forum_name' forum in Drupal");
							//Insert Container information into hierarchy table with parent
							$query = "INSERT INTO $d_term_hierarchy(tid, parent) ";
							$query .= "VALUES ('$maxtid', '$archive_id')";
							//message("Creating forum hierarchy for '$row->forum_name' forum in Drupal");
							$result2 = mysql_query($query, $link);
							if (!$result2)
							{
								failure("Could not set forum hierarchy.");
								exit();
							}
							//success("Created forum hierarchy for '$row->forum_name' forum in Drupal.");
							//Select Posts
							$query = "SELECT $n_posts.topic_id AS tid, $d_users.uid AS uid, $d_users.name AS name, $n_posts_text.post_subject AS title, ";
							$query .= "$n_posts_text.post_text AS text, $n_posts.post_time AS time, $n_posts.poster_ip AS ip ";
							$query .= "FROM $n_posts_text, $n_posts, $n_users, $d_users ";
							$query .= "WHERE $n_users.user_id=$n_posts.poster_id AND $n_posts.post_id=$n_posts_text.post_id ";
							$query .= "AND $n_posts.forum_id='$forum_id' AND ($d_users.name=$n_users.username) ";
							$query .= "ORDER BY $n_posts.topic_id, $n_posts.post_id";
							//message("Retrieving posts for $row->forum_name retrieved");
							$result3 = mysql_query($query, $link);
							if ($result3)
							{
								//success("Posts for $row->forum_name retrieved");
								$maxnid = get_max_id("node_nid");
								$maxcid = get_max_id("comments_cid");
								$nid = $maxnid + 1;
								$cid = $maxcid + 1;
								//topic controls post threading
								$topic = -1;
								while ($row = mysql_fetch_object($result3))
								{
									$row->title = addslashes($row->title);
									$row->text = addslashes($row->text);
									$row->ip = get_ip($row->ip);
									if ($topic != $row->tid)
									{
										$topic = $row->tid;
										$tid = $maxtid;
										$ptid = $nid;
										$threadid = 0;
										$counter++;
										$ptitle = $row->title;
										$query = "INSERT INTO $d_nodes(nid, type, title, uid, created, changed, comment, promote, teaser, body, format) ";
										$query .= "VALUES ('$nid', '$node_ftype', '$row->title', '$row->uid', '$row->time', '$row->time', '$comment', '$promote', 
															'$row->title', '$row->text', '$format')";
										//message("Inserting parent post '$row->title' in Drupal");
										$result2 = mysql_query($query, $link);
										if (!$result2)
										{
											failure("Error inserting post '$row->title'. ".$counter." fora + posts transferred in total");
											exit();
										}
										//success("Inserted parent post '$row->title' in Drupal");
										$query = "INSERT INTO $d_comment_statistics(nid, last_comment_timestamp, last_comment_uid, comment_count) ";
										$query .= "VALUES ('$nid', '$row->time', '$row->uid', '0')";
										//message("Registering comment statistic for post '$row->title' in Drupal");
										$result2 = mysql_query($query, $link);
										if (!$result2)
										{
											failure("Post comments statistics registration failed.");
											exit();
										}
										//success("Registered comment statistic for post '$row->title' in Drupal");
										$query = "INSERT INTO $d_fora(nid, tid) ";
										$query .= "VALUES ('$nid', '$tid')";
										//message("Updating forum table in Drupal");
										$result2 = mysql_query($query, $link);
										if (!$result2)
										{
											failure("Updating forum table Failed. ".$counter." fora + posts transferred in total");
											exit();
										}
										$query = "INSERT INTO $d_term_node(nid, tid) ";
										$query .= "VALUES ('$nid', '$tid')";
										//message("Updating term_node table for post '$row->title' in Drupal");
										$result2 = mysql_query($query, $link);
										if (!$result2)
										{
											failure("Updating term_node table failed. ".$counter." fora + posts transferred in total");
											exit();
										}
										$nid++;
									}
									else
									{
										$threadid++;
										$thread = $threadid."/";
										if (strlen($row->title) <= 0)
										{
											$row->title = $ptitle;
										}
										$query = "INSERT INTO $d_comments(cid, nid, uid, subject, comment, hostname, timestamp, format, thread, users, name) ";
										$query .= "VALUES ('$cid', '$ptid', '$row->uid', '$row->title', '$row->text', '$row->ip', '$row->time', '$format', '$thread', '$comment_user_string', '$row->name')";
										//message("Inserting comment post into comments table for post '$row->title' in Drupal");
										$result2 = mysql_query($query, $link);
										if (!$result2)
										{
											failure("Inserting comment post failed. ".$counter." fora + posts transferred in total");
											exit();
										}
										$counter++;
										//message("Inserted comment post into comments table for post '$row->title' in Drupal");
										$query = "UPDATE $d_comment_statistics SET last_comment_timestamp='$row->time', last_comment_name='$row->title', last_comment_uid='$row->uid', comment_count='$threadid' ";
										$query .= "WHERE nid='$ptid'";
										//message("Updating comment statistics for post '$row->title' in Drupal");
										$result2 = mysql_query($query, $link);
										if (!$result2)
										{
											failure("Post comments statistics registration failed.");
											exit();
										}
										//message("Updated comment statistics for post '$row->title' in Drupal");
										$cid++;
									}
								}
								set_max_id("node_nid", $nid - 1);
								set_max_id("comments_cid", $cid - 1);
							}
							else
							{
								failure("MySQL error. Nuke Posts could not be retrieved.");
								exit();
							}
						}
						set_max_id("term_data_tid", $maxtid);
						success($counter." fora + posts transferred successfully!");
						echo "<div class='options'>";
						echo "&nbsp;<a href='migrate.php'>Back To Main?</a>";
						echo "</div>";
						break;
					default:
						heading("Overview");
						if ($connected)
						{
							$query = "SELECT COUNT(*) AS usernum FROM $n_users";
							$result = mysql_query($query, $link);
							if ($row = mysql_fetch_object($result))
							{
								$usernum_n = $row->usernum;
							}
							$query = "SELECT COUNT(*) AS usernum FROM $d_users";
							$result = mysql_query($query, $link);
							if ($row = mysql_fetch_object($result))
							{
								$usernum_d = $row->usernum;
							}
							$query = "SELECT COUNT(*) AS storynum FROM $n_stories";
							$result = mysql_query($query, $link);
							if ($row = mysql_fetch_object($result))
							{
								$storynum = $row->storynum;
							}
						}
						echo "<ul>";
						echo "<li class='important'>";
						echo "Use this script at YOUR OWN RISK. No guarantees provided etc. etc. I have also not streamlined any of the SQL queries, as 
							  that wasn't really high on my priority list :P";
						echo "</li>";
						echo "<li>";
						echo "This is the migration script to move <em>only</em> users, stories and fora from the <a href='http://phpnuke.org/'>PHP-Nuke</a> CMS to the <a href='http://www.drupal.org'>Drupal</a> CMS.";
						echo "</li>";
						echo "<li>";
						echo "This has been tested <em>only</em> with migrating a site running PHP-Nuke 7.1 to a fresh installation of Drupal 4.6 (final).";
						echo "</li>";
						echo "<li>";
						echo "Best way to do this:";
						echo "<ul>";
						echo "<li>";
						echo "Create a local installation of Drupal.";
						echo "</li>";
						echo "<li>";
						echo "Then replace the contents of your local Drupal database with the Drupal database from your server (if there is one).";
						echo "</li>";
						echo "<li>";
						echo "Next, create another database and dump the PHP-Nuke database in it.";
						echo "</li>";
						echo "<li>";
						echo "Run this script. Once everything is done, test the local copy of Drupal to ensure that everything is A-OK.";
						echo "</li>";
						echo "<li>";
						echo "If so, replace the Drupal database on the server with this updated one.";
						echo "</li>";
						echo "<li>";
						echo "If your drupal site on the server is a live site, you might want to take it down during this process.";
						echo "</li>";
						echo "</ul>";
						echo "</li>";
						echo "<li>";
						echo "<span class='important'>Before proceeding,</span>";
						echo "<ul>";
						echo "<li class='important'>";
						echo "BACKUP everything if working directly on the server.";
						echo "</li>";
						echo "<li>";
						echo "Create your administrator account in Drupal.";
						echo "</li>";
						echo "<li>";
						echo "Add a test story.";
						echo "</li>";
						echo "<li>";
						echo "Add a test reply to the story.";
						echo "</li>";
						echo "<li>";
						echo "Add a test forum.";
						echo "</li>";
						echo "<li>";
						echo "Add a test post to the above forum.";
						echo "</li>";
						echo "<li>";
						echo "Add a test comment to the above forum post.";
						echo "</li>";
						echo "<li>";
						echo "If your administrator account in Drupal is named the same as an 
							  account in the PHP-Nuke database, add the account's username to
							  the \$user_array variable in this PHP files config settings.";
						echo "<li>";
						echo "Even if you are already using an existing Drupal installation, make sure that all the above steps are performed.";
						echo "</li>";
						echo "</ul>";
						echo "</li>";
						echo "<li class='important'>";
						echo "The above steps will initialise the database, 
							  and make it ready for the migration. Avoiding 
							  any of the above steps will result in failure.";
						echo "</li>";
						echo "<li>";
						echo "Things that this script will (at this point in time) <span class='important'>NOT</span> do:";
						echo "<ul>";
						echo "<li>";
						echo "Will not migrate comments from stories. Forum replies are migrated fine.";
						echo "<li>";
						echo "Will not migrate personal information of users. It migrates only the username, password and email address.";
						echo "<li>";
						echo "Will not migrate story or forum categories. The fora are transferred over as a lump. You can reorganise them in Drupal quite easily.";
						echo "</li>";
						echo "<li>";
						echo "Will not remove PHPbb tags from forum posts.";
						echo "</li>";
						echo "<li>";
						echo "Will not create sample titles if forum replies are missing titles. The title of the parent post is used.";
						echo "</li>";
						echo "<li>";
						echo "Besides users, stories and fora, nothing else is migrated.";
						echo "</li>";
						echo "</ul>";
						echo "</li>";
						echo "<li class='important'>";
						echo "BACKUP everything before proceeding.";
						echo "</li>";
						echo "<li>";
						echo "If you are ready, click on the 'Migrate Users' link at the bottom. If you get stuck at any point or run into errors, I recommend starting over again.";
						echo "</li>";
						if ($connected)
						{
							echo "<li>";
							echo "There are $usernum_n users and $storynum stories in the PHP-Nuke database.";
							echo "</li>";
							echo "<li>";
							echo "Currently, there are $usernum_d users in the Drupal database.";
							echo "</li>";
						}
						echo "</ul>";
						if ($connected)
						{
							echo "<div class='options'>";
							echo "<a href='migrate.php?section=users'>Migrate Users?</a>";
							echo "</div>";
						}
						break;
						//////////////////////////////////////////////////////////////////////////////////////////
				}
				if ($connected)	mysql_close($link);
			?>
		</div>
	</body>
</html>